<template>
  <SwPluginSlot name="gs-offcanvas-product" :slot-context="product">
    <SwGsOffcanvasProduct v-model="quantity"
                          :product="product"
                          :image="productImage"
                          :imageWidth="160"
                          :imageHeight="210"
                          :title="product.label"
                          :regular-price="formatPrice(regularPrice)"
                          :special-price="formatPrice(specialPrice)"
                          :disableQuantitySelector="disableQuantitySelector"
                          class="offcanvas-product"
                          @click:remove="removeProducts([product])"></SwGsOffcanvasProduct>
  </SwPluginSlot>
</template>

<script>
  import { getProductMainImageUrl } from "@shopware-pwa/helpers";
  import { ref, watch, computed, toRefs } from "@vue/composition-api";
  import { SfCollectedProduct, SfProperty } from "@storefront-ui/vue";
  import SwGsOffcanvasProduct from "./offcanvas/SwGsOffcanvasProduct.vue";
  import getResizedImage from "@/helpers/images/getResizedImage.js";
  import { usePriceFilter } from "../logic/composables/usePriceFilter";
  import { useGsCart } from "../logic/composables/useGsCart";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import {debounce} from "lodash";

  export default {
    name: "SwGsCartProduct",
    components: {
      SfCollectedProduct,
      SfProperty,
      SwGsOffcanvasProduct,
      SwPluginSlot
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
    },
    setup(props, {}) {
      const { formatPrice } = usePriceFilter();
      const { product } = toRefs(props)
      const disableQuantitySelector = ref(false);
      const { removeProducts, changeProducts } = useGsCart()
      const quantity = ref(product.value.quantity)
      const productImage = computed(() =>
        getResizedImage(getProductMainImageUrl(product.value), {
          width: 176,
          height: 210,
        })
      )
      // it's not 1:1 to Product entity interface
      const regularPrice = computed(
        () =>
          (product.value.price?.listPrice && product.value.price?.listPrice.price) ||
          product.value.price?.unitPrice
      )
      const specialPrice = computed(
        () => product.value.price?.listPrice && product.value.price?.unitPrice
      )

      const options = computed(
        () => (product.value.payload && product.value.payload.options) || []
      )

      const performChangeProducts = debounce(async (qty) => {
        disableQuantitySelector.value = true;
        try {
          await changeProducts([{ id: product.value.id, quantity: qty }]);
        } finally {
          disableQuantitySelector.value = false;
        }
      }, 1000);

      watch(quantity, async (qty) => {
        if (!qty) {
          performChangeProducts.cancel();
          return;
        }
        if (+qty === +product.value.quantity) return;
        // fix UX when user input value greater than maximum items in stock
        let temp;
        temp = +qty > +product.value.quantityInformation.maxPurchase ? +product.value.quantityInformation.maxPurchase : +qty;
        quantity.value = temp;
        performChangeProducts(temp);
      })

      watch(
        () => product.value.quantity,
        (qty) => {
          quantity.value = qty
        }
      )
      return {
        productImage,
        removeProducts,
        quantity,
        regularPrice,
        specialPrice,
        options,
        formatPrice,
        disableQuantitySelector
      }
    },
  }
</script>
<style lang="scss" scoped></style>
